﻿@page "/seasons/create"
@page "/seasons/edit/{Id:int}"

@using Models.SeasonData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject ISeasonRepository SeasonRepository
@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title Season</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@SeasonModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Sport</label>
                        <InputText @bind-Value="currentSport" class="form-control" disabled="true"></InputText>
                    </div>
                    <div class="form-group">
                        <label>Name</label>
                        <InputText @bind-Value="SeasonModel.Name" class="form-control"></InputText>
                        <ValidationMessage For="() => SeasonModel.Name" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title Season </button>
                        <NavLink href="seasons" class="btn btn-secondary">Back to Index</NavLink>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>



@code {

    [Parameter]
    public int? Id { get; set; }
    private SeasonDTO SeasonModel { get; set; } = new SeasonDTO();
    private IEnumerable<SeasonDTO> Seasons { get; set; } = new List<SeasonDTO>();
    private string Title { get; set; } = "Create";
    private string currentSport { get; set; }
    protected override async Task OnInitializedAsync()
    {
        currentSport = await localStorage.GetItemAsync<string>("sportName");
        if (Id != null)
        {
            //update
            Title = "Update";
            SeasonModel = await SeasonRepository.Get(Id.Value);
        }
        else
        {
            //create
            SeasonModel = new SeasonDTO();
        }
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            // add check if season is unique
            // --
            // --
            if (SeasonModel.Id != 0 && Title == "Update")
            {
                //update
                var updateSeason = await SeasonRepository.Update(SeasonModel, SeasonModel.Id);
                await JsRuntime.ToastrSuccess("Season updated successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/seasons", true);

            }
            else
            {
                //create
                Seasons = await SeasonRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
                SeasonModel.IsActive = false;
                if (Seasons.Count() == 0)
                {
                    SeasonModel.IsActive = true;
                }
                SeasonModel.SportId = await localStorage.GetItemAsync<int>("sportId");
                var createdResult = await SeasonRepository.Create(SeasonModel);

                await JsRuntime.ToastrSuccess("Season created successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/seasons", true);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}
